<template>
          <section>
        <h2>Administration des utilisateurs</h2>
        <v-data-table
        :headers="headers"
        :items="users"
        :items-per-page="10"
        class="elevation-1"
        locale="fr-FR"
        >
        <template v-if="item !== connectedUserId" v-slot:item.isValid="{ item }">
          <div v-if="connectedUserId !== item._id">
            <v-icon v-if="item.isValid" @click="unValidateUser(item)" class="text-success">mdi-account-check</v-icon>
            <v-icon v-else class="text-danger" @click="validateUser(item)" title="Valider l'utilisateur">mdi-account-remove</v-icon>
          </div>
        </template>
        <template v-slot:item.isAdmin="{ item }">
          <div v-if="connectedUserId !== item._id">
            <v-icon v-if="item.isAdmin"  @click="displayAdminConfirmModal(item)" class="text-success">mdi-check-bold</v-icon>
            <v-icon v-else class="text-danger" @click="displayAdminConfirmModal(item)" title="Valider l'utilisateur">mdi-window-close</v-icon>
          </div>
        </template>
        </v-data-table>
        <!-- Modal confirmation admin -->
        <b-modal v-model="confirmAdminModal" title="Validation de l'action">
          <p>Êtes-vous sur de vouloir définir <strong>{{computedName}}</strong> {{selectedUser && selectedUser.isAdmin ? "comme simple membre" : "comme nouvel administrateur"}} ?</p>
        <div slot="modal-footer">
            <b-btn class="m-1" variant="secondary" @click="confirmAdminModal = false">Annuler</b-btn>
            <b-btn class="m-1" variant="success" @click="confirmAdminAction(selectedUser)">Valider</b-btn>
        </div>
        </b-modal>
      </section>
</template>
<script lang="ts">
import { Component, Vue,Watch } from 'vue-property-decorator';
import { User } from '../../../transport/User';
import UserService from '../../../services/userService';
import store from '../../../store';

@Component
export default class ListUserTable extends Vue{
    private confirmAdminModal = false;
    private computedName: string = "";
    private selectedUser: User | null = null;
    private userService: UserService = null;

       /* eslint-disable no-constant-condition */
    headers = [
      { text: 'Nom', value: 'fullName', sortable: true},
      { text: 'Libellé', value: 'label', sortable: true },
      { text: 'Email', value: 'email', sortable: true },
      { text: 'Validé', value: "isValid", sortable: true },
      { text: 'Admin', value: 'isAdmin', sortable: true },
    ];
    /* eslint-enable no-constant-condition */
    users: User[] = [];

    mounted() {
      this.userService = new UserService();
      this.refreshTab();
    }
    @Watch("selectedUser", {deep: true})
    onUserChange(user){
      this.getComputedName(user)
    }
    get connectedUserId(){
      if(store.state.user)
        return store.state.user._id
      return null
    }
    refreshTab(){
      this.userService.getAllUsers().then(res => {
        this.users = res
      });
    }

    /**
     * Valide un utilisateur
     */
    validateUser(user: User){
      this.userService.validateUser(user._id).then(() => this.refreshTab())
    }

    unValidateUser(user: User){
      this.userService.unValidateUser(user._id).then(() => this.refreshTab())
    }

    displayAdminConfirmModal(user: User){
      this.selectedUser = user;
      this.confirmAdminModal = true;
    }
    /**
     * Ajoute un utilisateur comme admin
     */
    confirmAdminAction(user: User){
      if(user.isAdmin){
        this.userService.demoteUser(user._id).then(() =>  {
          this.refreshTab();
        })
      }else{
        this.userService.promoteUser(user._id).then(() => {
        this.refreshTab();
      })
      this.confirmAdminModal = false;
      }
    }
    
    getComputedName(user): void{
      if(user === null)
        this.computedName =  "";
      else if(user.fullName !== null)
        this.computedName = user.fullName
      else if(user.label !== null)
        this.computedName = user.label
      else
        this.computedName = ""
    }

}
 </script>
 